<template>
  <div>
    <div>
      <div v-if="count < 5">
        <h2 class="user_name">{{this.$route.params.infoPlayer.nickname}}</h2>
        <span class="count_questions">{{count + 1}}/5</span>
        <span class="score_compte">Score: {{this.score}}</span>
        <div class="load_bar">
          <div class="load_bar__inside" v-bind:style="{width: this.time *5 + '%'}"></div>
        </div>
        <div class="questions">
          <p>{{allQuestions[count].question}}</p>
        </div>
        <div class="container_answer" v-bind:class="{ clickable: noClickable }">
          <div
            class="answer"
            v-for="answer in allQuestions[count].incorrect_answers"
            v-on:click="nextQuestions(allQuestions[count].correct_answer, answer)"
            :key="answer"
          >
            <p
              v-if="answer === allQuestions[count].correct_answer"
              v-bind:class="classGood"
            >{{answer}}</p>
            <p v-else>{{answer}}</p>
          </div>
        </div>
        <div class="time">{{time}}</div>
      </div>
      <div v-else>
        <p class="end_game_text">Game Over! Your score is: {{score }}</p>
        <router-link class="button__home end_game" to="/">Home</router-link>
        <router-link class="button__home end_game" to="/scores">Top Score</router-link>
      </div>
    </div>
    <h2 v-if="answer === 'bad'" class="red">Wrong answer</h2>
    <h2 v-else-if="answer === 'good'" class="green">Bravo, good answer</h2>
  </div>
</template>

<script lang="ts">
import { mapGetters, mapActions } from "vuex";
import VueTimers from "vue-timers";
import { timer } from "vue-timers";
import Vue from "vue";
import firebase from 'firebase';
Vue.use(VueTimers);
export default Vue.extend({
  name: "Quizz",
  mounted:function(){
    if(!this.$route.params.infoPlayer){ // If there's no data to show we redirect to the form page
      this.$router.push({name: "form"})
    }
  },
  timers: {
    log: { 
      time: 1000, autostart: true, repeat: true 
      }
  },

  data(): {
    count: number;
    score: number;
    answer: string;
    time: number;
    noClickable: Boolean;
    allScores: null;
    classGood: string;
  } {
    return {
      count: 0,
      score: 0, 
      answer: "",
      time: 20,
      noClickable: false,
      allScores: null,
      classGood: ""
    };
  },
  methods: {
    saveScore(): void {
      this.$route.params.infoPlayer.score = this.score // We put the score in the infoPlayer Object
      this.sendScore(this.$route.params.infoPlayer); // Send the data
    },
    log() {
      if (!this.time) {
        this.count++;
        this.time = 20;
      } else {
        this.time = this.time - 1;
      }
    },
    ...mapActions(["fetchQuestions"]), 
    ...mapActions(["sendScore"]),
      
    nextQuestions(goodAnswer: string, answer: string){
      this.noClickable = true; // We disabled the clickabilty of a div to avoid multiple click

      // We have to use a setTimeout otherwhise the player couldn't see the right answer
      setTimeout(() => {
        this.time = 20; // We reset the time
        this.count++; // We display the next question
        this.answer = ""; // We set the answer to nothing
        this.noClickable = false; // We allow the click
        this.classGood = ""; // We change the class good answer to nothing
      }, 1300);

      if (answer !== goodAnswer) { // If the answer is wrong
        this.answer = "bad"; // We display a message
      } else { // If the answer is good
        this.answer = "good";
        this.score = this.score + 1 + this.time / 2;
      }
      this.classGood = "bgGreen"; // We display the good answer in green
      
      if (this.count >= 4) {
        return this.saveScore(); //We save the score
      }
    }
  },
  computed: mapGetters(["allQuestions"]),
  created() {
    this.fetchQuestions(this.$route.params.infoPlayer); // Send the data
  }
});
</script>

<style lang="scss">
.bgGreen {
  background-color: #1b8f41a1;
   color: white;
  height: 100%;
  width: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
}
.load_bar{
  width: 90%;
  height: 7px;
  margin: 20px 5%;
  border-radius: 15px;
}
.load_bar__inside{
  background-color: #0000ff6e;
  height: 100%;
  transition: width 1s linear 
}
.green {
  color: green;
  text-align: center;
  margin: 0;
  font-size: 25px;
}
.clickable {
  pointer-events: none;
}
.user_name {
  margin-left: 5%;
}
.end_game_text {
  font-size: 39px;
  font-weight: bold;
  margin: 15%;
  text-align: center;
}
.button__home.end_game {
  margin: auto;
  margin-top: 5%;
}
.time {
  position: absolute;
  top: 10%;
  left: 40%;
  font-size: 30px;
  border: 1px solid black;
  border-radius: 100%;
  width: 55px;
  height: 55px;
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
}

.red {
color: red;
    text-align: center;
    margin: 0;
    font-size: 25px;
}

.questions {
  width: 90%;
  margin: 5%;
  height: 135px;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: white;
  border: 2px solid silver;
  border-radius: 10px;
  text-align: center;
  color: #000000a6;
  font-weight: bold;
  font-size: 20px;
}

.questions > p {
  padding: 3px;
  line-height: 25px;
}

.container_answer {
  display: flex;
  justify-content: space-around;
  align-items: center;
  flex-wrap: wrap;
  width: 100%;
  margin: auto;
}
.answer:hover {
  cursor: pointer;
}
.answer {
  width: 100%;
  margin: 10px 5%;
  text-align: center;
  border: 4px solid #e43e3e70;
  background-color: #ff8686d9;
  border-radius: 5px;
  height: 60px;
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 2px;
  font-size: 18px;
  color: white;
  font-weight: bold;
}

.count_questions {
  position: absolute;
  top: 10%;
  right: 5%;
  font-size: 23px;
  border: 1px solid black;
  padding: 8px;
  border-radius: 100%;
}

.score_compte {
  margin: 5%;
  font-size: 22px;
}
</style>
